// Imagine++ project
// Project:  Balls
// Author:   keriven
// Date:     2007/10/18

#include <Imagine/Graphics.h>
using namespace Imagine;
#include <cstdlib>
#include <ctime>
using namespace std;

///////////////////////////////
// Constants of program
const int width=256;    // Window width
const int height=256;   // Window height
const int ball_size=4;  // Radius of ball
const int nb_balls=30;  // Number of balls

///////////////////////////////
// Random generator
// Call it only once, before Random()
void initRand() {
    srand((unsigned int)time(0));
}
// Between a and b
int random(int a,int b) {
    return a+(rand()%(b-a+1));
}

///////////////////////////////
// Random position and speed
void initBall(int &x,int &y,int &u,int &v,Color &c) {
    x=random(ball_size,width-ball_size);
    y=random(ball_size,height-ball_size);
    u=random(0,4);
    v=random(0,4);
    c=Color(byte(random(0,255)),
            byte(random(0,255)),
            byte(random(0,255)));
}

///////////////////////////////
// Display of ball
void displayBall(int x,int y,Color col) {
  fillRect(x-ball_size,y-ball_size,2*ball_size+1,2*ball_size+1,col);
}

///////////////////////////////
// Move ball
void moveBall(int &x,int &y,int &u,int &v) {
    // Left and right bouncing
    if(x+u>width-ball_size || x+u<ball_size)
        u=-u;
    // Top and bottom bouncing
    if(y+v<ball_size || y+v>height-ball_size)
        v=-v;
    // Update position
    x+=u;
    y+=v;
}

///////////////////////////////
// Main function
int main() {
    // Open the window
    openWindow(width,height);
    // Position and speed of balls
    int xb[nb_balls],yb[nb_balls],ub[nb_balls],vb[nb_balls];    
    Color cb[nb_balls]; // Colors of balls
    initRand();
    for(int i=0; i<nb_balls; i++) {
        initBall(xb[i],yb[i],ub[i],vb[i],cb[i]);
        moveBall(xb[i],yb[i],ub[i],vb[i]);
    }
    // Main loop
    while(true) {
        milliSleep(25);
        noRefreshBegin();
        for(int i=0; i<nb_balls; i++) {
            displayBall(xb[i],yb[i],WHITE);
            moveBall(xb[i],yb[i],ub[i],vb[i]);
            displayBall(xb[i],yb[i],cb[i]);
        }
        noRefreshEnd();
    }
    endGraphics();
    return 0;
}
